﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using Syncfusion.JavaScript;
using System.Collections;
using Syncfusion.Linq;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using System.Web.Script.Serialization;
using System.Reflection;
using esempioConfirmDelete.Models;

namespace esempioConfirmDelete.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {

            try
            {
               // ViewData["Error"] = "Errore in controller GridFeatures";
                //code that throws an error
                //byte a = 0;
                //ulong c = 12345678999999888777;
                //var b = c / a;
                ///////////////////////////////
                Session["culture"] = "en-US";
            }
            catch (Exception ex)
            {
                ViewData["Error"] = "Errore in controller GridFeatures";
            }


            return View(ViewData["Error"]);
        }


  
        public bool checkbox { get; set; }


        public ActionResult DataSource(DataManager dm, bool? ckFlagTratt)
        {
            try
            {
                //code that throws an error
                byte a = 0;
                ulong c = 12345678999999888777;
                var b = c / a;
                ///////////////////////////////

                //var DataSource = OrderRepository.GetAllRecords().Where(p => p.Verified == ckFlagTratt).Take(20).ToList();
                var DataSource = OrderRepository.GetAllRecords().Where(p => p.Verified == ckFlagTratt).Take(20).ToList();
                DataResult result = new DataResult();
                if (ckFlagTratt == null)
                    DataSource = OrderRepository.GetAllRecords().Where(p => p.Verified == false).Take(20).ToList();
                result.result = DataSource.Skip(dm.Skip).Take(dm.Take).ToList();
                result.count = DataSource.Count();
                return Json(result, JsonRequestBehavior.AllowGet);

            }
            catch (Exception ex)
            {
                HttpContext.Response.AddHeader("Exception", "Error loading");
                Response.StatusCode = ex.HResult; //set failure in request.
                Session["Error"] = "Errore in loading";
                return RedirectToAction("GridFeatures", "Grid");
                //throw new Exception("Error deleting");
            }
        }

       

        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

        public ActionResult CrudUpdate(EditableOrder value, string action, List<EditableOrder> deleted, string key)
        {
            //Qui si mette il codice di accesso al DB e verifica utente
            try
            {
                byte a = 0;
                ulong p = 12345678999999888777;
                var b = p / a;
                if (action == "insert")
                {

                    OrderRepository.Add(value);


                }


                if (action == "update")
                {
                    OrderRepository.Update(value);
                }
                if (action == "remove")
                {
                    OrderRepository.Delete(deleted);
                }

                return RedirectToAction("GridFeatures", "Grid");

                //return View("Festivita");

            }
            catch (Exception ex)
            {
                HttpContext.Response.AddHeader("Exception", "Error deleting");
                Response.StatusCode = ex.HResult; //set failure in request.
                return View("GridFeatures", "Grid");
                //throw new Exception("Error deleting");
            }


        }












    }
}
